JSUB	stinit
		LDB	#array
		BASE	array
		LDS	elem_sz
		LDT	#0
		LDA	#0
		LDX	#0
		JSUB	get_input
		LDA	input_tmp
		SUB	charzero
		STA	total_sz
		STA	sz
		RMO	A, T
		MULR	T, A
		MUL	elem_sz
		RMO	A, T
		JSUB	get_input
for_input_loop	JSUB	get_input
		LDA	input_tmp
		COMP	newline
		JEQ	for_input_loop
		SUB	charzero		
		STA	array, X
		ADDR	S, X
		COMPR	X, T
		JLT	for_input_loop

		. calcuate start
		LDX	#0
		LDA	total_sz
		MUL	elem_sz

		. row_width = total_size * elem_sz
		STA	row_width

		. quad_tree(row, col, sz)
		JSUB	quad_tree
		JSUB	get_input
return_main	J	return_main


. quad_tree(row, col, sz)
quad_tree	STL	oldl
		. push return address
		LDA	oldl
		JSUB	push

		LDA	row_width
		MUL	row
		RMO	A, S
		LDA	elem_sz
		MUL	col
		ADDR	S, A

		. X = starting address
		RMO	A, X
		LDA	row
		ADD	sz
		SUB	#1
		MUL	row_width
		RMO	A, S
		LDA	col
		ADD	sz
		MUL	elem_sz
		ADDR	S, A

		. end address
		STA	end_addr

		LDA	sz
		MUL	elem_sz
		. cur_row_width = sz * elem_siz
		STA	cur_row_width

		. cur = array[row][col]
		LDA	#0
		LDA	array, X
		STA	cur

		. check_flag = true
		LDA	#1
		STA	check_flag

. loop
for_check_loop	LDA	array, X
		J	for_inner_loop
check_equal	LDA	check_flag
		COMP	#0
		JEQ	check_low_level
		RMO	X, A
		ADD	row_width
		RMO	A, X
		COMP	end_addr
		JLT	for_check_loop
		LDA	#0
		LDA	cur
		ADD	charzero
		STA	output_tmp
		JSUB	print
		J	return_quad

check_low_level	LDA	#0
		LDCH	=C'('
		STA	output_tmp	
		JSUB	print

		. sz = sz/2
		LDA	sz
		DIV	#2
		STA	sz

		. call recursivly
		. 1. quad_tree(row, col, sz)
		LDA	row
		JSUB	push
		LDA	col
		JSUB	push
		LDA	sz
		JSUB	push

		JSUB	quad_tree

		JSUB	pop
		STA	sz
		JSUB	pop
		STA	col
		JSUB	pop
		STA	row

		. 2. quad_tree(row, col+sz, sz)
		LDA	row
		JSUB	push
		LDA	col
		JSUB	push
		LDA	sz
		JSUB	push

		LDA	col
		ADD	sz
		STA	col

		JSUB	quad_tree

		JSUB	pop
		STA	sz
		JSUB	pop
		STA	col
		JSUB	pop
		STA	row

		. 3. quad_tree(row+sz, col, sz)
		LDA	row
		JSUB	push
		LDA	col
		JSUB	push
		LDA	sz
		JSUB	push

		LDA	row
		ADD	sz
		STA	row

		JSUB	quad_tree

		JSUB	pop
		STA	sz
		JSUB	pop
		STA	col
		JSUB	pop
		STA	row

		. 4. quad_tree(row+sz, col+sz, sz)
		LDA	row
		JSUB	push
		LDA	col
		JSUB	push
		LDA	sz
		JSUB	push

		LDA	col
		ADD	sz
		STA	col

		LDA	row
		ADD	sz
		STA	row

		JSUB	quad_tree

		JSUB	pop
		STA	sz
		JSUB	pop
		STA	col
		JSUB	pop
		STA	row

		LDCH	=C')'
		STA	output_tmp	
		JSUB	print
		J	return_quad		

for_inner_loop	STX	oldx
		LDA	cur_row_width
		ADDR	X, A
		STA	next_row_limit
check_loop	LDA	array, X
		COMP	cur
		JEQ	continue
		LDA	#0
		STA	check_flag
		LDX	oldx
		J	check_equal

continue	LDA	#3
		ADDR	A, X
		LDA	next_row_limit
		COMPR	X, A
		JLT	check_loop
		LDX	oldx
		J	check_equal

. return to main
return_quad	JSUB	pop
		RMO	A, L
		RSUB


oldx		RESW	1

get_input	TD	stdin
		JEQ	get_input
		RD	stdin
		STA	input_tmp
		RSUB

print		TD	stdout
		JEQ	print
		LDA	output_tmp
		WD	stdout
		RSUB

. stack code
stinit		LDA	#st
		STA	top
		STA	bottom
		RSUB

push		STA	@top
		LDA	top
		ADD	#3
		STA	top
		RSUB

pop		LDA	top
		SUB	#3
		STA	top
		LDA	@top
		RSUB

. stack variable
st		RESW	100
top		RESW	1
bottom		RESW	1
oldl		RESW	1

. in/output
stdin		BYTE	X'00'
stdout		BYTE	X'01'
charzero	WORD	X'000030'
newline		WORD	X'00000A'

input_tmp	RESW	1
output_tmp	RESW	1

. 2D arr
array		RESW	64
total_sz	RESW	1
row_width	RESW	1
cur_row_width	RESW	1
next_row_limit	RESW	1
check_flag	RESW	1
end_addr	RESW	1
cur		RESW	1
elem_sz		WORD	3
row		WORD	0
col		WORD	0
sz		RESW	1